<?php
/**
 * @file
 * Contains Login Settings for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
include "mo_saml_visualTour.php";
 function miniorange_saml_login_options($form, &$form_state)
 {
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

     global $base_url;

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

  $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

     $form['markup_tophead-1'] = array(
         '#markup' => '<div class="mo_saml_table_layout mo_saml_container"  id="mosaml_redirect_chckbx">',
     );

  $form['markup_1'] = array(
    '#markup' => '<b><span style="font-size: 17px;">SIGN IN SETTINGS</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
        . 'Take a Tour</a><br><br><hr><br/>',
  );

     $form['markup_prem_plans'] = array(
         '#markup' => '<div class="mo_saml_highlight_background_note">Available in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Standard,Premium,Enterprise</a></b> versions of the module</div><br>',
     );

  $form['miniorange_saml_force_auth'] = array(
    '#type' => 'checkbox',
    '#title' => t('Protect website against anonymous access.'),
	'#disabled' => TRUE,
    '#attributes' => array('id'=>'mosaml_chkbx_prot'),
    '#description' => t('<b>Note: </b>Users will be redirected to your IdP for login in case user is not logged in and tries to access website.<br><br>'),
  );


  $form['miniorange_saml_auto_redirect'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to <b>auto redirect the user to IdP.</b>'),
    '#default_value' => variable_get('miniorange_saml_auto_redirect_to_idp'),
	'#disabled' => TRUE,
      '#attributes' => array('id'=>'mosaml_vt_auto_redirect'),
      '#description' => t('<b>Note: </b>Users will be redirected to your IdP for login when the login page is accessed.<br><br>'),
  );

  $form['miniorange_saml_enable_backdoor'] = array(
    '#type' => 'checkbox',
    '#title' => t('Check this option if you want to enable <b>backdoor login.</b>'),
    '#default_value' => variable_get('miniorange_saml_enable_backdoor', ''),
	'#disabled' => TRUE,
    '#attributes' => array('id'=>'mosaml-chkbx-enable-backdoor'),
    '#description' => t('<b>Note: </b>Checking this option <b>creates a backdoor to login to your Website using Drupal credentials</b>'
          . ' incase you get locked<br> out of your IdP. Note down this URL: We provide a bcakdoor URL in the <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Standard,Premium,Enterprise]</b></a> versions of the module.<br><br>'),
  );

     $form['miniorange_saml_default_relaystate'] = array(
         '#type' => 'textfield',
         '#title' => t('Default Redirect URL after login.'),
         '#default_value' => variable_get('miniorange_saml_default_relaystate', ''),
         '#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','id'=>'mosaml_def_redirect','placeholder' => 'Enter Default Redirect URL'),
         '#disabled' => TRUE,
     );

     $form['mo_saml_br_button'] = array(
         '#markup' => '</br>',
     );

     $form['miniorange_saml_gateway_config_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#submit' => array('miniorange_saml_save_signin_settings'),
         '#disabled' => TRUE,
         '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
           box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),

     );

     $form['markup_support_close1'] = array(
         '#markup' => '</div>',
     );

     $form['miniorange_idp_guide_link'] = array(
         '#markup' => '<div class="mo_saml_table_layout mo_saml_container_2">',
     );

     $form['miniorange_idp_guide_link1'] = array(
         '#markup' => '<div style="font-size: 15px;"><b>To see detailed documentation of how to configure Drupal 7 SAML Service Provider with any Identity Provider</b></div></br>',
     );

     Utilities::spConfigGuide($form, $form_state);


     $form['miniorange_idp_guide_link_end'] = array(
         '#markup' => '</div>',
     );

     Utilities::AddSupportButton($form, $form_state);

  return $form;

 }
 function miniorange_saml_save_signin_settings($form, &$form_state) {

 	drupal_set_message(t('Signin Settings successfully saved'));

 }


/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    Utilities::send_query($email, $phone, $query);
}