<?php
/**
 * @file
 * Contains Attribute and Role Mapping for miniOrange SAML Login Module.
 */

 /**
 * Showing Settings form.
 */
include "mo_saml_visualTour.php";
 function miniorange_saml_mapping($form, &$form_state)
 {
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

     global $base_url;

     /****************************************************************ATTRIBUTE MAPPING************************************************************/

     $form['markup_top'] = array(
         '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container"><b><span style="font-size: 17px;">ATTRIBUTE MAPPING</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
             . 'Take a Tour</a><br><br><hr><br/>'
     );

     $form['miniorange_saml_account_username_by'] = array(
        '#type' => 'select',
        '#title' => t('Login/Create Drupal account by'),
        '#options' => array(1 => t('Username'), 2 => t('Email')),
        '#default_value' => variable_get('miniorange_saml_login_by'),
        '#attributes' => array('style' => 'width:68%','id'=>'mosaml_vt_username'),
     );

    $form['miniorange_saml_vt_mapp'] = array(
       '#markup'=>'<div id="miniorange_saml_vt_mapping">'
    );

    $form['miniorange_saml_username_attribute'] = array(
        '#type' => 'textfield',
        '#title' => t('Username Attribute'),
        '#default_value' => variable_get('miniorange_saml_username_attribute', 'NameID'),
        '#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Username attribute'),
	    '#disabled' => TRUE,
    );

    $form['miniorange_saml_email_attribute'] = array(
        '#type' => 'textfield',
        '#title' => t('Email Attribute'),
        '#default_value' => variable_get('miniorange_saml_email_attribute', 'NameID'),
        '#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Email attribute'),
	    '#disabled' => TRUE,
    );

    $form['miniorange_saml_idp_attr1_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('Role'),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Role Attribute'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );

     $form['miniorange_saml_vt_mapp2'] = array(
         '#markup'=>'</div>'
     );

     $form['Configure_Attribute_Mapping_End'] = array(
         '#markup' => '<div class="mo_saml_highlight_background_note_1"><b>Username</b> and <b>Email Attribute</b> are configurable in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Standard, Premium, Enterprise</a></b> versions of the module.<br>
                    <b>Role</b> is configurable in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Standard, Premium, Enterprise</a></b> versions of the module.<br></div><br>',
     );

     $form['miniorange_saml_gateway_config_atrr_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#submit' => array('miniorange_saml_save_mapping_settings'),
         '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
           box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
     );

    /****************************************************************Documentation guides table************************************************************/

     $form['miniorange_idp_guide_link'] = array(
         '#markup' => '</div><div class="mo_saml_table_layout mo_saml_container_2">',
     );

     $form['miniorange_idp_guide_link1'] = array(
         '#markup' => '<div style="font-size: 15px;"><b>To see detailed documentation of how to configure Drupal 7 SAML Service Provider with any Identity Provider</b></div></br>',
     );

     Utilities::spConfigGuide($form, $form_state);

     $form['miniorange_idp_guide_link_end'] = array(
         '#markup' => '</div>',
     );

     /****************************************************************CUSTOM ATTRIBUTE MAPPING************************************************************/

     $form['markup_cam_attr'] = array(
         '#markup' => '<br><div class="mo_saml_table_layout mo_saml_container"><h4>CUSTOM ATTRIBUTE MAPPING </h4><hr><br><div class="mo_saml_highlight_background_note"><b>NOTE : Custom Attribute Mapping</b> are configurable in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Premium, Enterprise</a></b> versions of the module.</div>',
     );

     $form['markup_cam'] = array(
         '#markup' => '<br><div class="mo_saml_highlight_background_note_1"><p><b>NOTE: </b> Add the Drupal field attributes in the Attribute Name textfield and add the IdP attibutes that you need to map with the drupal attributes in the IdP Attribute Name textfield. 
                                   <br> <b>Attribute Name:</b> It is the user attribute (machine name) whose value you want to set in site.
                                   <br> <b>IdP Attribute Name:</b> It is the name which you want to get from your IDP. It should be unique.</p></div><p><b>For example: If the attribute name in the drupal is name then its machine name will be field_name.</b></p>',
     );

     $form['miniorange_saml_vt_Custmapp'] = array(
         '#markup'=>'<div id="miniorange_saml_vt_customAttr">'
     );
  
    $form['miniorange_saml_attr5_name'] = array(
	    '#type' => 'textfield',
	    '#title' => t('Attribute Name 1 '),
	    '#default_value' => variable_get('miniorange_saml_attr5_name', ''),
	    '#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Attribute Name'),
	    '#required' => FALSE,
	    '#disabled' => TRUE,
    );
  
    $form['miniorange_saml_idp_attr5_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('IdP Attribute Name 1 '),
    	'#default_value' => variable_get('miniorange_saml_idp_attr5_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter IdP Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_attr2_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('Attribute Name 2 '),
    	'#default_value' => variable_get('miniorange_saml_attr2_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_idp_attr2_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('IdP Attribute Name 2 '),
    	'#default_value' => variable_get('miniorange_saml_idp_attr2_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter IdP Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_attr3_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('Attribute Name 3 '),
    	'#default_value' => variable_get('miniorange_saml_attr3_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_idp_attr3_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('IdP Attribute Name 3 '),
    	'#default_value' => variable_get('miniorange_saml_idp_attr3_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter IdP Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_attr4_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('Attribute Name 4 '),
    	'#default_value' => variable_get('miniorange_saml_attr4_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );
  
    $form['miniorange_saml_idp_attr4_name'] = array(
    	'#type' => 'textfield',
    	'#title' => t('IdP Attribute Name 4 '),
    	'#default_value' => variable_get('miniorange_saml_idp_attr4_name', ''),
    	'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter IdP Attribute Name'),
    	'#required' => FALSE,
    	'#disabled' => TRUE,
    );

     $form['miniorange_saml_vt_Custmapp2'] = array(
         '#markup'=>'</div>'
     );

     $form['markup_idp_user_attr_header'] = array(
         '#markup' => '<br /><h4> ADDITIONAL USER ATTRIBUTES (OPTIONAL)<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Premium, Enterprise]</b></a> <input type="button" class="btn btn-primary" style="width:3%;margin-left:2%;margin-right:2%;" value="+" onclick="add_user_attibute();" /> <input type="button" class="btn btn-danger" style="width:3%;" value="-" onclick="remove_user_attibute();" /></h4>',
     );

     $form['markup_idp_user_attr_note'] = array(
         '#markup' => '<div class="messages status">Attribute Name: It is the user attribute (machine name) whose value you want to set in site.<br />IdP Attribute Name: It is the name which you want to get from your IDP. It should be unique.</div><br>',
     );

     $form['miniorange_saml_gateway_config_custom_attr_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#disabled' => TRUE,
         '#submit' => array('miniorange_saml_save_mapping_settings'),
         '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
           box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
     );

     /****************************************************************CUSTOM Role MAPPING************************************************************/

     $form['markup_role'] = array(
         '#markup' => '</br></div><div class="mo_saml_table_layout mo_saml_container"><h4>ROLE MAPPING </h4><hr><br>',
     );

     $form['mosaml_vt_checkbx']=array('#markup'=>'<div id="mosaml_vt_enable_chckbx">');

     $form['miniorange_saml_enable_rolemapping'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you want to <b>enable Role Mapping</b>'),
         '#default_value' => variable_get('miniorange_saml_enable_rolemapping'),
     );

     $form['mosaml_vt_checkbx1']=array('#markup'=>'</div>');

     $form['mosaml_vt_defGroup']=array('#markup'=>'<div id="mosaml_vt_defaut_group">');

     $mrole= user_roles($membersonly = TRUE);
     $drole = array_search(variable_get('miniorange_saml_default_role',''),$mrole);

     $form['miniorange_saml_default_mapping'] = array(
         '#type' => 'select',
         '#title' => t('Select default group for the new users'),
         '#options' => $mrole,
         '#default_value' => $drole,
         '#attributes' => array('style' => 'width:68%'),
     );

     $form['mosaml_vt_defGroup1']=array('#markup'=>'</div>');

     $form['miniorange_saml_prem_features'] = array(
         '#markup'=>'<div class="mo_saml_highlight_background_note_1">'
     );

     $form['miniorange_disable_attribute'] = array(
         '#type' => 'checkbox',
         '#title' => t('Do not update existing user&#39;s role.'),
         '#disabled' => TRUE,
         '#description'=>t('This feature is availabe in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing">Premium, Enterprise</a></b> versions of the module.'),
     );

     $form['miniorange_saml_disable_role_update'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you do not want to update user role if roles not mapped.'),
         '#disabled' => TRUE,
         '#description'=>t('This feature is availabe in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing">Premium, Enterprise</a></b> versions of the module.'),
     );

     $form['miniorange_saml_disable_autocreate_users'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option if you want to disable <b>auto creation</b> of users if user does not exist.'),
         '#description'=>t('This feature is availabe in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing">Premium, Enterprise</a></b> versions of the module.'),
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_prem_features_end'] = array(
         '#markup'=>'</div><br>'
     );

     $form['markup_role_end'] = array(
         '#markup' => '<br><h4>CUSTOM ROLE MAPPING </h4><hr>',
     );

     $form['markup_cam_attr_map1'] = array(
         '#markup' => '<br><div class="mo_saml_highlight_background_note"><b>NOTE : Custom Role Mapping</b> are configurable in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Premium, Enterprise</a></b> versions of the module.</div><br>',
     );

	foreach($mrole as $roles) {
        $rolelabel = str_replace(' ','',$roles);
        $form['miniorange_saml_role_' . $rolelabel] = array(
	        '#type' => 'textfield',
	        '#title' => t($roles),
	        '#default_value' => variable_get('miniorange_saml_role_' . $rolelabel, ''),
	        '#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
	        '#required' => FALSE,
	        '#disabled' => TRUE,
        );
    }

     $form['miniorange_saml_vt_CustLog'] = array(
         '#markup'=>'<div id="miniorange_saml_vt_customLogin">'
     );

    $form['markup_role_signin'] = array(
        '#markup' => '</br><h4>CUSTOM LOGIN/LOGOUT (OPTIONAL): </h4><hr>'
    );

    $form['markup_cam_log_1'] = array(
        '#markup' => '<br><div class="mo_saml_highlight_background_note_1"><b>NOTE : Custom Login/Logout </b> are configurable in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Premium, Enterprise</a></b> versions of the module.</div><br>',
    );
  
	foreach($mrole as $drupalKey=>$drupalRoles) {
		$lbl = str_replace(' ','',$drupalRoles . '_sin');
		$l= str_replace(' ','',$drupalRoles . '_sout');
		$form[$lbl] = array(
			'#type' => 'textfield',
			'#title' => $drupalRoles,
			'#default_value' => variable_get($lbl, ''),
			'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Login URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
        );

		$form[$l] = array(
			'#type' => 'textfield',
			'#default_value' => variable_get($l, ''),
			'#attributes' => array('style' => 'width:68%;background-color: hsla(0,0%,0%,0.08) !important;','placeholder' => 'Enter Logout URL'),
			'#required' => FALSE,
			'#disabled' => TRUE,
        );
	}

     $form['miniorange_saml_vt_CustLog2'] = array(
         '#markup'=>'</div>'
     );

    $form['miniorange_saml_gateway_config_custom_role_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Save Configuration'),
        '#submit' => array('miniorange_saml_save_mapping_settings'),
        '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
            box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7;display: block;margin-left: auto;margin-right: auto;'),
    );

    $form['markup_support_close1'] = array(
        '#markup' => '</div>',
    );

    Utilities::AddSupportButton($form, $form_state);

    return $form;

 }
 
  function miniorange_saml_save_mapping_settings($form, &$form_state) {
      $mrole= user_roles($membersonly = TRUE);
      $enable_rolemapping = $form['miniorange_saml_enable_rolemapping']['#value'];
      $login_by = $form['miniorange_saml_account_username_by']['#value'];
      $username_attribute = $form['miniorange_saml_username_attribute']['#value'];
      $email_attribute = $form['miniorange_saml_email_attribute']['#value'];
      $default_mapping= $form['miniorange_saml_default_mapping']['#value'];
      if($enable_rolemapping == 1) {
          $enable_rolemapping = TRUE;
      }
      else {
          $enable_rolemapping = FALSE;
      }
      variable_set('miniorange_saml_enable_rolemapping', $enable_rolemapping);
      if($enable_rolemapping) {
          variable_set('miniorange_saml_default_role', $mrole[$default_mapping]);
        }
      else {
          variable_set('miniorange_saml_default_role', $mrole[2]);
        }
      variable_set('miniorange_saml_login_by', $login_by);
      variable_set('miniorange_saml_username_attribute', $username_attribute);
      variable_set('miniorange_saml_email_attribute', $email_attribute);
      drupal_set_message(t('Mapping Configuration Settings successfully saved'));
  }

/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    Utilities::send_query($email, $phone, $query);
}